diff --git a/Makefile b/Makefile
index 7742461..47599e7 100644
--- a/Makefile
+++ b/Makefile
@@ -55,7 +55,7 @@ recurse-all: $(SUBDIR_RULES) $(ROMSUBDIR_RULES)

 block-obj-y = cutils.o cache-utils.o qemu-malloc.o qemu-option.o module.o
 block-obj-y += nbd.o block.o aio.o aes.o
-block-obj-$(CONFIG_AIO) += posix-aio-compat.o
+block-obj-$(CONFIG_POSIX_AIO) += posix-aio-compat.o

 block-nested-y += cow.o qcow.o vmdk.o cloop.o dmg.o bochs.o vpc.o vvfat.o
 block-nested-y += qcow2.o qcow2-refcount.o qcow2-cluster.o qcow2-snapshot.o
diff --git a/block/raw-posix.c b/block/raw-posix.c
index bdee07f..7f4c562 100644
--- a/block/raw-posix.c
+++ b/block/raw-posix.c
@@ -27,7 +27,7 @@
 #include "qemu-log.h"
 #include "block_int.h"
 #include "module.h"
-#ifdef CONFIG_AIO
+#ifdef CONFIG_POSIX_AIO
 #include "posix-aio-compat.h"
 #endif

@@ -489,7 +489,7 @@ static int raw_write(BlockDriverState *bs, int64_t sector_num,
     return ret;
 }

-#ifdef CONFIG_AIO
+#ifdef CONFIG_POSIX_AIO
 /***********************************************************/
 /* Unix AIO using POSIX AIO */

@@ -725,12 +725,12 @@ static BlockDriverAIOCB *raw_aio_writev(BlockDriverState *bs,
     }
     return &acb->common;
 }
-#else /* CONFIG_AIO */
+#else /* CONFIG_POSIX_AIO */
 static int posix_aio_init(void)
 {
     return 0;
 }
-#endif /* CONFIG_AIO */
+#endif /* CONFIG_POSIX_AIO */


 static void raw_close(BlockDriverState *bs)
@@ -906,7 +906,7 @@ static BlockDriver bdrv_raw = {
     .bdrv_create = raw_create,
     .bdrv_flush = raw_flush,

-#ifdef CONFIG_AIO
+#ifdef CONFIG_POSIX_AIO
     .bdrv_aio_readv = raw_aio_readv,
     .bdrv_aio_writev = raw_aio_writev,
 #endif
@@ -1026,7 +1026,7 @@ static int hdev_open(BlockDriverState *bs, const char *filename, int flags)
 #endif

     s->type = FTYPE_FILE;
-#if defined(__linux__) && defined(CONFIG_AIO)
+#if defined(__linux__) && defined(CONFIG_POSIX_AIO)
     if (strstart(filename, "/dev/sg", NULL)) {
         bs->sg = 1;
     }
@@ -1092,7 +1092,7 @@ static int hdev_ioctl(BlockDriverState *bs, unsigned long int req, void *buf)
     return ioctl(s->fd, req, buf);
 }

-#ifdef CONFIG_AIO
+#ifdef CONFIG_POSIX_AIO
 static BlockDriverAIOCB *hdev_aio_ioctl(BlockDriverState *bs,
         unsigned long int req, void *buf,
         BlockDriverCompletionFunc *cb, void *opaque)
@@ -1183,7 +1183,7 @@ static BlockDriver bdrv_host_device = {
     .bdrv_create        = hdev_create,
     .bdrv_flush		= raw_flush,

-#ifdef CONFIG_AIO
+#ifdef CONFIG_POSIX_AIO
     .bdrv_aio_readv	= raw_aio_readv,
     .bdrv_aio_writev	= raw_aio_writev,
 #endif
@@ -1195,7 +1195,7 @@ static BlockDriver bdrv_host_device = {
     /* generic scsi device */
 #ifdef __linux__
     .bdrv_ioctl         = hdev_ioctl,
-#ifdef CONFIG_AIO
+#ifdef CONFIG_POSIX_AIO
     .bdrv_aio_ioctl     = hdev_aio_ioctl,
 #endif
 #endif
@@ -1283,7 +1283,7 @@ static BlockDriver bdrv_host_floppy = {
     .bdrv_create        = hdev_create,
     .bdrv_flush         = raw_flush,

-#ifdef CONFIG_AIO
+#ifdef CONFIG_POSIX_AIO
     .bdrv_aio_readv     = raw_aio_readv,
     .bdrv_aio_writev    = raw_aio_writev,
 #endif
@@ -1365,7 +1365,7 @@ static BlockDriver bdrv_host_cdrom = {
     .bdrv_create        = hdev_create,
     .bdrv_flush         = raw_flush,

-#ifdef CONFIG_AIO
+#ifdef CONFIG_POSIX_AIO
     .bdrv_aio_readv     = raw_aio_readv,
     .bdrv_aio_writev    = raw_aio_writev,
 #endif
@@ -1381,7 +1381,7 @@ static BlockDriver bdrv_host_cdrom = {

     /* generic scsi device */
     .bdrv_ioctl         = hdev_ioctl,
-#ifdef CONFIG_AIO
+#ifdef CONFIG_POSIX_AIO
     .bdrv_aio_ioctl     = hdev_aio_ioctl,
 #endif
 };
@@ -1488,7 +1488,7 @@ static BlockDriver bdrv_host_cdrom = {
     .bdrv_create        = hdev_create,
     .bdrv_flush         = raw_flush,

-#ifdef CONFIG_AIO
+#ifdef CONFIG_POSIX_AIO
     .bdrv_aio_readv     = raw_aio_readv,
     .bdrv_aio_writev    = raw_aio_writev,
 #endif
diff --git a/configure b/configure
index 80e2838..2f6310a 100755
--- a/configure
+++ b/configure
@@ -198,7 +198,7 @@ uname_release=""
 curses="yes"
 curl="yes"
 pthread="yes"
-aio="yes"
+posix_aio="yes"
 io_thread="no"
 nptl="yes"
 mixemu="no"
@@ -257,7 +257,7 @@ DragonFly)
   if [ "$cpu" = "i386" -o "$cpu" = "x86_64" ] ; then
     kqemu="yes"
   fi
-  aio="no"
+  posix_aio="no"
 ;;
 NetBSD)
   bsd="yes"
@@ -364,7 +364,7 @@ if test "$mingw32" = "yes" ; then
   EXESUF=".exe"
   QEMU_CFLAGS="-DWIN32_LEAN_AND_MEAN -DWINVER=0x501 $QEMU_CFLAGS"
   LIBS="-lwinmm -lws2_32 -liphlpapi $LIBS"
-  aio=no
+  posix_aio=no
 fi

 # find source path
@@ -505,7 +505,7 @@ for opt do
   ;;
   --disable-pthread) pthread="no"
   ;;
-  --disable-aio) aio="no"
+  --disable-aio) posix_aio="no"
   ;;
   --enable-io-thread) io_thread="yes"
   ;;
@@ -645,7 +645,7 @@ echo "  --enable-uname-release=R Return R for uname -r in usermode emulation"
 echo "  --sparc_cpu=V            Build qemu for Sparc architecture v7, v8, v8plus, v8plusa, v9"
 echo "  --disable-vde            disable support for vde network"
 echo "  --disable-pthread        disable pthread support"
-echo "  --disable-aio            disable AIO support"
+echo "  --disable-aio            disable POSIX AIO support"
 echo "  --enable-io-thread       enable IO thread"
 echo "  --disable-blobs          disable installing provided firmware blobs"
 echo "  --kerneldir=PATH         look for kernel includes in PATH"
@@ -1201,7 +1201,7 @@ EOF
 fi

 if test "$pthread" = no; then
-   aio=no
+   posix_aio=no
    io_thread=no
 fi

@@ -1535,7 +1535,7 @@ echo "uname -r          $uname_release"
 echo "NPTL support      $nptl"
 echo "GUEST_BASE        $guest_base"
 echo "vde support       $vde"
-echo "AIO support       $aio"
+echo "POSIX AIO support $posix_aio"
 echo "IO thread         $io_thread"
 echo "Install blobs     $blobs"
 echo -e "KVM support       $kvm"
@@ -1707,8 +1707,8 @@ fi
 if test "$xen" = "yes" ; then
   echo "CONFIG_XEN=y" >> $config_host_mak
 fi
-if test "$aio" = "yes" ; then
-  echo "CONFIG_AIO=y" >> $config_host_mak
+if test "$posix_aio" = "yes" ; then
+  echo "CONFIG_POSIX_AIO=y" >> $config_host_mak
 fi
 if test "$io_thread" = "yes" ; then
   echo "CONFIG_IOTHREAD=y" >> $config_host_mak